package com.client;

import com.shared.FieldVerifier;
import com.google.gwt.core.client.EntryPoint;
import com.google.gwt.core.client.GWT;
import com.google.gwt.event.dom.client.ClickEvent;
import com.google.gwt.user.client.ui.RadioButton;
import com.google.gwt.user.client.ui.Panel;
import com.google.gwt.user.client.ui.VerticalPanel;
import com.google.gwt.event.dom.client.ClickHandler;
import com.google.gwt.event.dom.client.KeyCodes;
import com.google.gwt.event.dom.client.KeyDownEvent;
import com.google.gwt.event.dom.client.KeyDownHandler;
import com.google.gwt.event.dom.client.KeyUpEvent;
import com.google.gwt.event.dom.client.KeyUpHandler;
import com.google.gwt.dom.client.NativeEvent;
import com.google.gwt.user.client.rpc.AsyncCallback;
import com.google.gwt.user.client.ui.RootPanel;
import com.google.gwt.user.client.ui.TextArea;
import com.google.gwt.canvas.client.Canvas;
import com.google.gwt.event.dom.client.*;

/**
 * Entry point classes define <code>onModuleLoad()</code>.
 */
public class InputEventDemo implements EntryPoint, ClickHandler {

  TextArea EventReporter;
  boolean shiftDown=false,altDown=false,controlDown=false;

//  ClickHandler WhaHappened;

  /**
   * This is the entry point method.
   */
  public void onModuleLoad() {

    Canvas Blot=Canvas.createIfSupported();
    // Set size of panel
    Blot.setSize("30","30");

    EventReporter=new TextArea();
    EventReporter.setCharacterWidth(80);
    EventReporter.setVisibleLines(10);

    Blot.addStyleName("blot");
    EventReporter.addStyleName("eventReporter");
    
    Panel RPanel=new VerticalPanel();
    RadioButton Buttons[]=new RadioButton[3];
    //Buttons = new RadioButton[3];
    
//  WhaHappened=newClickHandler();
    for (int idx=0;idx<3;idx++) {
      Buttons[idx]  = new RadioButton("myRadioGroup", "foo"+String.valueOf(idx));
      RPanel.add(Buttons[idx]);
      Buttons[idx].addClickHandler(this);
    }
    
    RootPanel.get("Blot").add(Blot);
    RootPanel.get("EventReporter").add(EventReporter);
    RootPanel.get("Radios").add(RPanel);

    // Listen for the Key Press
    Blot.addKeyDownHandler(new KeyDownHandler() {
       /**
       * Invoked when a key has been pressed.
       */
       public void onKeyDown(KeyDownEvent event) {
	  // First, did they hit enter? If not, ignore
	if (!shiftDown && !controlDown && !altDown)
	  EventReporter.setText(EventReporter.getText()+"\nKey Pressed:");
        if (event.isShiftKeyDown() && !shiftDown) {
	  EventReporter.setText(EventReporter.getText()+"Shift ");
	  shiftDown=true;
        }
        else if (event.isAltKeyDown() && !altDown){
	  EventReporter.setText(EventReporter.getText()+"Alt ");
	  altDown=true;
        }
        else if (event.isControlKeyDown() && !controlDown){
	  EventReporter.setText(EventReporter.getText()+"Ctrl ");
	  controlDown=true;
        }
	else 
	  EventReporter.setText(EventReporter.getText()+
					event.getNativeKeyCode());
	EventReporter.getElement().setScrollTop
			(EventReporter.getElement().getScrollHeight());
      }
    });
    
    Blot.addKeyUpHandler(new KeyUpHandler() {
       /**
       * Invoked when a key has been released.
       */
       public void onKeyUp(KeyUpEvent event) {
	 // Need to determine which keys were released
         if (shiftDown && !event.isShiftKeyDown())
           shiftDown=false;
         if (altDown && !event.isAltKeyDown())
           altDown=false;
         if (controlDown && !event.isControlKeyDown())
           controlDown=false;
       }
    });   
    
    Blot.addClickHandler(new ClickHandler() {
       /**
       * Invoked when the mouse is clicked.
       */
       public void onClick(ClickEvent event) {
	 String whichButton=null;
         if (event.getNativeButton()==NativeEvent.BUTTON_LEFT)
	   whichButton="Left";
         else if (event.getNativeButton()==NativeEvent.BUTTON_MIDDLE)
	   whichButton="Middle";
         else if (event.getNativeButton()==NativeEvent.BUTTON_RIGHT)
	   whichButton="Right";
         EventReporter.setText(EventReporter.getText()+"\n "+whichButton+
			" Button Click at("+event.getX()+","+event.getY()+")");
         EventReporter.getElement().setScrollTop
			(EventReporter.getElement().getScrollHeight());
       }
    });
    
    final class MyMouseHandler implements MouseOverHandler, MouseOutHandler
    {
	public void onMouseOver(MouseOverEvent event) 
	{ EventReporter.setText(EventReporter.getText()+
		"\n Mouse Entered at("+event.getX()+","+event.getY()+")");
          EventReporter.getElement().setScrollTop
			(EventReporter.getElement().getScrollHeight());

	}
	
	public void onMouseOut(MouseOutEvent event) 
	{ EventReporter.setText(EventReporter.getText()+
		"\n Mouse Exited at("+event.getX()+","+event.getY()+")");
          EventReporter.getElement().setScrollTop
			(EventReporter.getElement().getScrollHeight());

	}
    }
    
    MyMouseHandler MyHandler=new MyMouseHandler();
    
    Blot.addMouseOverHandler(MyHandler);   
    Blot.addMouseOutHandler(MyHandler);   
      
  }
  
  public void onClick(ClickEvent TheClick)
  {  EventReporter.setText(EventReporter.getText()+"\n Radio Button Clicked: "+
                                ((RadioButton)TheClick.getSource()).getText());
     EventReporter.getElement().setScrollTop
			(EventReporter.getElement().getScrollHeight());
  }
}
